#!/path/to/perl
#     Perl   

###############################################################################
# testmysql.cgi
###############################################################################
# TestMySQL v1.0 Freeware
#    MySQL.
# :   (support@top-top.ru)
# =============================================================================
#     : http://www.top-top.ru/products/scripts/
# =============================================================================
# Copyright Fortex+ (c) 2002
###############################################################################

use DBI;
use CGI::Carp qw(fatalsToBrowser);

$lit_winl_s="abcdefghijklmnopqrstuvwxyz";
$lit_winl_b="ABCDEFGHIJKLMNOPQRSTUVWXYZ";

$lit_winr_s="";
$lit_winr_b="Ũ";

$lit_koir_s="ţ";
$lit_koir_b="";

$buffer="$ENV{'QUERY_STRING'}";
@pairs=split(/&/,$buffer);
foreach $pair (@pairs) {
 ($name,$value)=split(/=/,$pair);
 $name=~tr/+/ /;
 $name=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $value=~tr/+/ /;
 $value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $FORM{$name}=$value;
}

if ($FORM{'step'} eq '') {
$out_str=<<"[END]";
<br><p align="center"><strong><font size="4">     MySQL</font></strong></p>
<p><font size="2">       .    
 &quot;&quot;        MySQL
   DBI.</font></p>
<div align="center"><center>
<form action="/cgi-bin/testmysql.cgi" method="GET">
<input type="hidden" name="step" value="1">
<table border="0" cellspacing="0">
<tr><td align="right"> :</td>
<td><input type="text" name="db_host" size="20"></td></tr>
<tr><td align="right"> :</td>
<td><input type="text" name="db_user" size="20"></td></tr>
<tr><td align="right">:</td>
<td><input type="text" name="db_password" size="20"></td></tr>
<tr><td align="right">  :</td>
<td><input type="text" name="db_name" size="20"></td></tr>
<tr><td></td><td align="right"><input type="submit" value=""></td></tr>
</table></form></center></div>
[END]
}

if ($FORM{'step'} eq '1') {
 $dbh=DBI->connect("DBI:mysql:$FORM{'db_name'}:$FORM{'db_host'}",$FORM{'db_user'},$FORM{'db_password'});
 $str=$DBI::errstr;
 if ($str ne '') {
  $out_str=<<"[END]";
<br><p align="center"><strong><font size="4">      MySQL</font></strong></p>
<p>: $str</p>
[END]
 }
 else {
  $lit_win_all="$lit_winl_b$lit_winl_s$lit_winr_b$lit_winr_s";
  $lit_koi_all="$lit_winl_b$lit_winl_s$lit_koir_b$lit_koir_s";
  $dbh->do("create table testdb(strwin char(1), strkoi char(1))");
  (@lit_winall)=split(//,$lit_win_all);
  (@lit_koiall)=split(//,$lit_koi_all);
  for($i=0; $i<scalar(@lit_winall); $i++) {
   $dbh->do("insert into testdb(strwin, strkoi) values('$lit_winall[$i]', '$lit_koiall[$i]')");
  }
  $sth=$dbh->prepare("SELECT strwin FROM testdb ORDER BY strwin ASC");
  $sth->execute();
  while ((@row=$sth->fetchrow_array)) {
   $row_str_win.="$row[0]";
  }
  $sth=$dbh->prepare("SELECT strkoi FROM testdb ORDER BY strkoi ASC");
  $sth->execute();
  while ((@row=$sth->fetchrow_array)) {
   $row_str_koi.="$row[0]";
  }
  $dbh->do("delete from testdb");
  $dbh->do("drop table testdb");
  $lenall=length($lit_win_all);
  $dbh->do("create table testdb(strregw char($lenall), strregk char($lenall))");
  $dbh->do("insert into testdb(strregw, strregk) values('$lit_win_all', '$lit_koi_all')");
  $sth=$dbh->prepare("SELECT lcase(strregw), lcase(strregk) FROM testdb");
  $sth->execute();
  @row_lcase=$sth->fetchrow_array;
  $sth=$dbh->prepare("SELECT lower(strregw), lower(strregk) FROM testdb");
  $sth->execute();
  @row_lower=$sth->fetchrow_array;
  $sth=$dbh->prepare("SELECT ucase(strregw), ucase(strregk) FROM testdb");
  $sth->execute();
  @row_ucase=$sth->fetchrow_array;
  $sth=$dbh->prepare("SELECT upper(strregw), upper(strregk) FROM testdb");
  $sth->execute();
  @row_upper=$sth->fetchrow_array;
  $dbh->do("delete from testdb");
  $dbh->do("drop table testdb");
  $sth=$dbh->prepare("SELECT version()");
  $sth->execute();
  @version=$sth->fetchrow_array;
  $sth=$dbh->prepare("SHOW VARIABLES");
  $sth->execute();
  while ((@row=$sth->fetchrow_array)) {
   $row_var.="$row[0]=$row[1]<br>";
  }
  $out_str=<<"[END]";
<br><p align="center"><strong><font size="4">    MySQL</font></strong></p>
<p><u> MySQL:</u> $version[0]</p>
<p><u>  MySQL   "cp1251":</u></p>
<p><u> :</u><br>
<font size="2">$lit_win_all</font><br>
<u> :</u><br>
<font size="2">$row_str_win</font><br>
<u>    ():</u><br>
<font size="2">&nbsp;"lcase":&nbsp;$row_lcase[0]<br>
&nbsp;"lower":&nbsp;$row_lower[0]</font><br>
<u>    ():</u><br>
<font size="2">&nbsp;"ucase":&nbsp;$row_ucase[0]<br>
&nbsp;"upper":&nbsp;$row_upper[0]</font></p>
<p><u>  MySQL   "koi8_ru":</u></p>
<p><u> :</u><br>
<font size="2">$lit_koi_all</font><br>
<u> :</u><br>
<font size="2">$row_str_koi</font><br>
<u>    ():</u><br>
<font size="2">&nbsp;"lcase":&nbsp;$row_lcase[1]<br>
&nbsp;"lower":&nbsp;$row_lower[1]</font><br>
<u>    ():</u><br>
<font size="2">&nbsp;"ucase":&nbsp;$row_ucase[1]<br>
&nbsp;"upper":&nbsp;$row_upper[1]</font></p>
<p><u> :</u><br>
<font size="2">$row_var</font></p>
[END]
 }
}

print "Content-type: text/html\n\n";
print << "[END]";
<html>
<head><title>   MySQL &quot;TestMySQL&quot; v1.0</title></head>
<body>
$out_str
<hr width="100%">
<p align="center"><font size="2">   MySQL: <a
 href="http://www.top-top.ru/products/scripts/">&quot;TestMySQL&quot; v1.0 Freeware</a><br>
   : <a href="mailto:support\@top-top.ru">.</a><br>
Copyright Fortex+  2002</font></p>
</body>
</html>
[END]

